<?php
/*
 * pickup_message.php
 *
 * @(#) $Header: /home/mlemos/cvsroot/mimemessage/pickup_message.php,v 1.3 2004/09/22 21:21:31 mlemos Exp $
 *
 *
 */


class pickup_message_class extends email_message_class
{
	/* Private variables */

	var $line_break="\r\n";
	var $pickup_file=0;
	var $pickup_file_name="";

	/* Public variables */

	var $mailroot_directory="";
 	var $mailer_delivery='pickup $Revision: 1.3 $';

	Function CleanupMessageFile()
	{
		if($this->pickup_file)
		{
			fclose($this->pickup_file);
			$this->pickup_file=0;
			unlink($this->pickup_file_name);
		}
	}

	Function StartSendingMessage()
	{
		if(strlen($this->mailroot_directory)==0)
		{
			if(function_exists("class_exists")
			&& class_exists("COM"))
			{
				$shell=new COM("WScript.Shell");
				$wwwroot=$shell->RegRead("HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\InetStp\\PathWWWRoot");
				if(is_dir($wwwroot))
				{
					$mailroot=$wwwroot."\\..\\mailroot";
					if(is_dir($mailroot."\\Pickup"))
						$this->mailroot_directory=$mailroot;
					else
					{
						$mailroot=$wwwroot."\\mailroot";
						if(is_dir($mailroot."\\Pickup"))
							$this->mailroot_directory=$mailroot;
					}
				}
			}
		}
		if(strlen($this->mailroot_directory)==0)
			return($this->OutputError("it was not specified the mailroot directory path"));
		if(!is_dir($this->mailroot_directory."\\Pickup"))
			return($this->OutputError("the specified mailroot path ".$this->mailroot_directory." does not contain a Pickup directory"));
		$this->pickup_file_name=tempnam(GetEnv("TMP"),"eml");
		if(!($this->pickup_file=@fopen($this->pickup_file_name,"w")))
			return($this->OutputPHPError("could not create a pickup message file ".$this->pickup_file_name, $php_errormsg));
		return("");
	}

	Function SendMessageHeaders($headers)
	{
		for($error=$header_data="",$message_id_set=$date_set=0,$header=0,$return_path=$sender=$receivers=array(),Reset($headers);$header<count($headers);$header++,Next($headers))
		{
			$header_name=Key($headers);
			switch(strtolower($header_name))
			{
				case "return-path":
					$return_path[$headers[$header_name]]=1;
					break;
				case "from":
					$error=$this->GetRFC822Addresses($headers[$header_name],$sender);
					break;
				case "to":
				case "cc":
				case "bcc":
					$this->GetRFC822Addresses($headers[$header_name],$receivers);
					break;
				case "date":
					$date_set=1;
					break;
				case "message-id":
					$message_id_set=1;
					break;
			}
			if(strlen($error))
			{
				$this->CleanupMessageFile();
				return($this->OutputError($error));
			}
			switch(strtolower($header_name))
			{
				case "x-sender":
				case "x-receiver":
				case "bcc":
					break;
				default:
					$header_data.=$this->FormatHeader($header_name,$headers[$header_name])."\r\n";
			}
		}
		if(count($sender)==0)
		{
			$this->CleanupMessageFile();
			return($this->OutputError("it was not specified a valid From header"));
		}
		if(count($receivers)==0)
		{
			$this->CleanupMessageFile();
			return($this->OutputError("it was not specified a valid To header"));
		}
		Reset($return_path);
		Reset($sender);
		$envelop="x-sender: ".(count($return_path) ? Key($return_path) : Key($sender)).$this->line_break;
		for($receiver=0,Reset($receivers);$receiver<count($receivers);Next($receivers),$receiver++)
			$envelop.="x-receiver: ".Key($receivers).$this->line_break;
		if(!$date_set)
			$header_data.="Date: ".strftime("%a, %d %b %Y %H:%M:%S %Z").$this->line_break;
		if(!$message_id_set
		&& $this->auto_message_id)
		{
			$sender=(count($return_path) ? Key($return_path) : Key($sender));
			$header_data.=$this->GenerateMessageID($sender).$this->line_break;
		}
		if(!@fputs($this->pickup_file, $envelop.$header_data.$this->line_break))
		{
			$this->CleanupMessageFile();
			return($this->OutputPHPError("could not write the message headers to the pickup file", $php_errormsg));
		}
		return("");
	}

	Function SendMessageBody($data)
	{
		if(!@fputs($this->pickup_file, $data))
		{
			$this->CleanupMessageFile();
			return($this->OutputPHPError("could not write the message body to the pickup file", $php_errormsg));
		}
		return("");
	}

	Function EndSendingMessage()
	{
		if(!@fflush($this->pickup_file))
			return($this->OutputPHPError("could not flush the message body to the pickup file", $php_errormsg));
		fclose($this->pickup_file);
		$this->pickup_file=0;
		$pickup_file_path=$this->mailroot_directory;
		if(strcmp(substr($pickup_file_path,strlen($pickup_file_path)-1,1),"\\"))
			$pickup_file_path.="\\";
		$pickup_file_path.="Pickup\\";
		if(!@copy($this->pickup_file_name,$pickup_file_path.basename($this->pickup_file_name)))
			$error=$this->OutputPHPError("could not copy the message file to the pickup directory", $php_errormsg);
		else
			$error="";
		unlink($this->pickup_file_name);
		return($error);
	}

	Function StopSendingMessage()
	{
		return("");
	}

};

?>
