<?php
/*
 * smtp_message.php
 *
 * @(#) $Header: /home/mlemos/cvsroot/mimemessage/smtp_message.php,v 1.27 2004/10/05 18:11:27 mlemos Exp $
 *
 *
 */

class smtp_message_class extends email_message_class
{
	/* Private variables */

	var $smtp;
	var $line_break="\r\n";

	/* Public variables */
	var $localhost="";
 	var $smtp_host="localhost";
	var $smtp_port=25;
	var $smtp_direct_delivery=0;
	var $smtp_getmxrr="getmxrr";
	var $smtp_exclude_address="";
	var $smtp_user="";
	var $smtp_realm="";
	var $smtp_workstation="";
	var $smtp_password="";
	var $smtp_pop3_auth_host="";
	var $smtp_debug=0;
	var $smtp_html_debug=0;
	var $esmtp=1;
	var $timeout=25;
	var $invalid_recipients=array();
	var $mailer_delivery='smtp $Revision: 1.27 $';

	Function SetRecipients(&$recipients,&$valid_recipients)
	{
		for($valid_recipients=$recipient=0,Reset($recipients);$recipient<count($recipients);Next($recipients),$recipient++)
		{
			$address=Key($recipients);
			if($this->smtp->SetRecipient($address))
				$valid_recipients++;
			else
				$this->invalid_recipients[$address]=$this->smtp->error;
		}
		return(1);
	}

	Function StartSendingMessage()
	{
		if(function_exists("class_exists")
		&& !class_exists("smtp_class"))
			return("the smtp_class class was not included");
		if(IsSet($this->smtp))
			return("");
		$this->smtp=new smtp_class;
		$this->smtp->localhost=$this->localhost;
		$this->smtp->host_name=$this->smtp_host;
		$this->smtp->host_port=$this->smtp_port;
		$this->smtp->timeout=$this->timeout;
		$this->smtp->debug=$this->smtp_debug;
		$this->smtp->html_debug=$this->smtp_html_debug;
		$this->smtp->direct_delivery=$this->smtp_direct_delivery;
		$this->smtp->getmxrr=$this->smtp_getmxrr;
		$this->smtp->exclude_address=$this->smtp_exclude_address;
		$this->smtp->pop3_auth_host=$this->smtp_pop3_auth_host;
		$this->smtp->user=$this->smtp_user;
		$this->smtp->realm=$this->smtp_realm;
		$this->smtp->workstation=$this->smtp_workstation;
		$this->smtp->password=$this->smtp_password;
		$this->smtp->esmtp=$this->esmtp;
		if($this->smtp->Connect())
			return("");
		$error=$this->smtp->error;
		UnSet($this->smtp);
		return($this->OutputError($error));
	}

	Function SendMessageHeaders($headers)
	{
		for($header_data="",$message_id_set=$date_set=0,$header=0,$return_path=$from=$to=$recipients=array(),Reset($headers);$header<count($headers);$header++,Next($headers))
		{
			$header_name=Key($headers);
			switch(strtolower($header_name))
			{
				case "return-path":
					$return_path[$headers[$header_name]]=1;
					break;
				case "from":
					$error=$this->GetRFC822Addresses($headers[$header_name],$from);
					break;
				case "to":
					$error=$this->GetRFC822Addresses($headers[$header_name],$to);
					break;
				case "cc":
				case "bcc":
					$this->GetRFC822Addresses($headers[$header_name],$recipients);
					break;
				case "date":
					$date_set=1;
					break;
				case "message-id":
					$message_id_set=1;
					break;
			}
			if(strcmp($error,""))
				return($this->OutputError($error));
			if(strtolower($header_name)=="bcc")
				continue;
			$header_data.=$this->FormatHeader($header_name,$headers[$header_name])."\r\n";
		}
		if(count($from)==0)
			return($this->OutputError("it was not specified a valid From header"));
		if(count($to)==0)
			return($this->OutputError("it was not specified a valid To header"));
		Reset($return_path);
		Reset($from);
		$this->invalid_recipients=array();
		if(!$this->smtp->MailFrom(count($return_path) ? Key($return_path) : Key($from))
		|| !$this->SetRecipients($to,$valid_recipients))
			return($this->OutputError($this->smtp->error));
		if($valid_recipients==0)
			return($this->OutputError("it were not specified any valid recipients"));
		if(!$date_set)
			$header_data.="Date: ".strftime("%a, %d %b %Y %H:%M:%S %Z")."\r\n";
		if(!$message_id_set
		&& $this->auto_message_id)
		{
			$sender=(count($return_path) ? Key($return_path) : Key($from));
			$header_data.=$this->GenerateMessageID($sender)."\r\n";
		}
		if(!$this->SetRecipients($recipients,$valid_recipients)
		|| !$this->smtp->StartData()
		|| !$this->smtp->SendData("$header_data\r\n"))
			return($this->OutputError($this->smtp->error));
		return("");
	}

	Function SendMessageBody($data)
	{
		$this->smtp->PrepareData($data,$output);
		return($this->smtp->SendData($output) ? "" : $this->OutputError($this->smtp->error));
	}

	Function EndSendingMessage()
	{
		return($this->smtp->EndSendingData() ? "" : $this->OutputError($this->smtp->error));
	}

	Function StopSendingMessage()
	{
		if($this->bulk_mail
		&& !$this->smtp_direct_delivery)
			return("");
		$error=($this->smtp->Disconnect() ? "" : $this->OutputError($this->smtp->error));
		UnSet($this->smtp);
		return($error);
	}

	Function ChangeBulkMail($on)
	{
		if($on
		|| !IsSet($this->smtp))
			return(1);
		$error=($this->smtp->Disconnect() ? "" : $this->OutputError($this->smtp->error));
		UnSet($this->smtp);
		return(strlen($error)==0);
	}
};
?>
